# Makefile - Rules for building PIC32 deployment payloads
#
# Copyright (C) 2015, 2017, 2018 Paul Boddie <paul@boddie.org.uk>
# Copyright (C) Xiangfu Liu <xiangfu@sharism.cc>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

.PHONY:	all clean distclean

all:	$(HEX) $(SREC)

clean:
	rm -f $(OBJ) $(TARGET) $(HEX) $(SREC) $(DUMP) *.map

distclean: clean
	echo "Nothing else to clean."

$(HEX): $(TARGET)
	$(OBJCOPY) -O ihex $(TARGET) $(HEX)

$(SREC): $(TARGET)
	$(OBJCOPY) -O srec $(TARGET) $(SREC)

$(TARGET): $(OBJ)
	$(LD) $(LDFLAGS) -T $(SCRIPT) $(OBJ) -o $@
	$(OBJDUMP) -D $(TARGET) > $(DUMP)
	$(OBJDUMP) -h $(TARGET) > $(MAP)
	$(NM) -n $(TARGET) > System.map

.c.o:
	$(CC) -c $(CFLAGS) $< -o $@

.S.o:
	$(CC) -c $(CFLAGS) $< -o $@
